#!/bin/bash
GPIO_VIDEO4=443
GPIO_VIDEO3=442
SD_CLK=482
SD_DATA2=486
AVS_ENB=${SD_CLK}
DUT_RSTB=${SD_DATA2}
PCIE_PWR_EN=${GPIO_VIDEO4}
EJTAG_RSTB=${GPIO_VIDEO3}

function gpio_check_export()
{
	if [ ! -d "/sys/class/gpio/gpio${1}" ];then
		echo ${1} > /sys/class/gpio/export
	fi
}

function reset_pcie_swith()
{
	# Reset all gpio to low
	echo out > /sys/class/gpio/gpio${PCIE_PWR_EN}/direction
	echo 0 > /sys/class/gpio/gpio${PCIE_PWR_EN}/value

	echo out > /sys/class/gpio/gpio${EJTAG_RSTB}/direction
	echo 0 > /sys/class/gpio/gpio${EJTAG_RSTB}/value

	echo out > /sys/class/gpio/gpio${AVS_ENB}/direction
	echo 0 > /sys/class/gpio/gpio${AVS_ENB}/value

	echo out > /sys/class/gpio/gpio${DUT_RSTB}/direction
	echo 0 > /sys/class/gpio/gpio${DUT_RSTB}/value

	sleep 1

	# Do pcie reset gpio sequence
	echo 1 > /sys/class/gpio/gpio${PCIE_PWR_EN}/value
	sleep 0.5
	echo 1 > /sys/class/gpio/gpio${DUT_RSTB}/value
	sleep 0.1
	echo 1 > /sys/class/gpio/gpio${AVS_ENB}/value
	echo 1 > /sys/class/gpio/gpio${EJTAG_RSTB}/value
	sleep 1
}

gpio_check_export ${PCIE_PWR_EN}

gpio_check_export ${EJTAG_RSTB}

gpio_check_export ${AVS_ENB}

gpio_check_export ${DUT_RSTB}

# Actually Start pcie
modprobe -r hobot-pcie-rc

reset_pcie_swith

modprobe hobot-pcie-rc

if [ $(lspci | wc -l ) -lt 2 ];then
	echo "WARNING: PCIe Switch Initialization might have Failed, please check!"
fi
