#!/bin/bash

check_firmware_version()
{
	firmware1=$(114xfwdl -D | grep Version | awk 'NR==1, /Version/ {print $3}')
	firmware2=$(114xfwdl -D | grep Version | awk 'NR==2, /Version/ {print $3}')

	if [[ $firmware1 != 241106_71_02_41 || $firmware2 != 241106_71_02_41 ]]; then
		return 1
	else
		return 0
	fi
}

wait_xhci_usb_ready()
{
	# Totally 5 seconds timeout...
	for i in `seq 0 10`
	do
		if ! lsmod | grep -q xhci_hcd; then
			echo "xhci not ready? wait..."
			sleep 0.5
			continue
		fi

		root_hubs=$(lsusb 2>/dev/null | grep -c "root hub")
		if [ $root_hubs -ne 4 ]; then
			echo "usb count not okay... wait..."
			sleep 0.5
			continue
		fi

		break
	done

	echo "usb ready, continue..."

	# echo "wait 500ms more..."
	# sleep 0.5
}

wait_xhci_usb_ready
version_info=$(114xfwdl -D)
check_firmware_version
if [ $? -eq 0 ]; then
	echo "$version_info"
	echo "asm3042 firmware already latest."
elif [ $? -eq 1 ]; then
	echo "current asm3042 firmware info as below:"
	echo "$version_info"

	echo "update to 241106_71_02_41 version now!"

	114xfwdl -u /usr/lib/firmware/asmedia/241106_71_02_41.bin

	echo "wait 2 seconds..."
	sleep 2
	check_firmware_version
	if [ $? -eq 0 ]; then
		echo "asm3042 firmware update succeed... please reboot system..."
	else
		echo "asm3042 firmware update fail... some abnormal happen..."
	fi

else
	echo "asm3042 firmware version check abnormal..."
	echo "$version_info"
fi

echo "$0 done..."
